var TARGET_URL = "cgi-bin/pipe-config";
var BASE_SKYPE_QOE_IMG_URL = "img/"; //"http://placehold.it/50x50/";


/// utilities
// convert a configuration to two POST requests necessary to apply the complete configuration (one per pipe)
var configurationToCgiPostRequest = function(configuration) {
  return {
    'upload': {
      pipe:  10,
      bw:    configuration.upload.bandwidth,
      delay: configuration.upload.delay,
      plr:   configuration.upload.lossrate
    },
    'download': {
      pipe:  11,
      bw:    configuration.download.bandwidth,
      delay: configuration.download.delay,
      plr:   configuration.download.lossrate
    }
  }
}

var cgiPostRequestToConfiguration = function(req) {

  if(req.pipe === undefined)
    throw "pipe cannot be undefined";

  var direction = req.pipe === 10? 'upload' : 'download';
  var res = {};
  res[direction] = {
    'bandwidth': req.bw,
    'delay':     req.delay,
    'lossrate':  req.plr
  };

  return res;
}

/// UI
// set correct image per QoE class
var setSkypeQoE = function(value) {
  var imgUrl = BASE_SKYPE_QOE_IMG_URL;
  switch (value) {
    case "Excellent":
  //     imgUrl += "C1D37F/664E4C?text=4";
      // break;
    case "Good":
  //     imgUrl += "FFFD82/664E4C?text=3";
      // break;
    case "Poor":
  //     imgUrl += "FF9B71/664E4C?text=2";
      // break;
    case "No Call":
  //     imgUrl += "E84855/664E4C?text=1";
      imgUrl += value + ".png";
      break;
    default:
  //     imgUrl += "003049/FFFFFF?text=&#fffd";
      imgUrl += "undefined.png";
  }

  if(imgUrl !== BASE_SKYPE_QOE_IMG_URL) {
    $('#skype-qoe-img').attr('src', imgUrl);
  }
}

// update the output view (only defined parts)
var updateView = function(conf) {
  if(conf.upload !== undefined) {
    if(conf.upload.bandwidth !== undefined)
      $('#UploadBandwidth').val(conf.upload.bandwidth);
    if(conf.upload.delay !== undefined)
      $('#UploadDelay').val(conf.upload.delay);
    if(conf.upload.lossrate !== undefined)
      $('#UploadLossRate').val(conf.upload.lossrate);
  }

  if(conf.download !== undefined) {
    if(conf.download.bandwidth !== undefined)
      $('#DownloadBandwidth').val(conf.download.bandwidth);
    if(conf.download.delay !== undefined)
      $('#DownloadDelay').val(conf.download.delay);
    if(conf.download.lossrate !== undefined)
      $('#DownloadLossRate').val(conf.download.lossrate);
  }

  if(conf.expected !== undefined) {
    setSkypeQoE(conf.expected);
  }
}


var currentConfiguration = configurations[0];
var uploadPipeReady   = true;
var downloadPipeReady = true;

// define callback on selecting a new configuration
$('#selectConfiguration').on('change', function() {
    var conf = configurations[this.value];

    if(currentConfiguration === conf)
      return;

    var uploadPipeReady   = false;
    var downloadPipeReady = false;

    var request = configurationToCgiPostRequest(conf);

    // show loading
    $('#loadingConfiguration').removeClass('invisible');

    var posting;
    posting = $.post(TARGET_URL, request.upload);
    posting.done(function(data) {
       console.log(data);

        uploadPipeReady = true;
        if(downloadPipeReady) {
          $('#loadingConfiguration').addClass('invisible');
        }

        updateView({'upload': conf.upload, 'expected': conf.expected});
    });

    posting = $.post(TARGET_URL, request.download);
    posting.done(function(data) {
        console.log(data);

        downloadPipeReady = true;
        if(uploadPipeReady) {
          $('#loadingConfiguration').addClass('invisible');
        }

        updateView({'download': conf.download, 'expected': conf.expected});
    });

    currentConfiguration = conf;
});

// set manually the configuration
$('.net-control').focusout(function() {
  // TODO
});


// init on document ready
$(document).ready(function() {
  // TODO move here initialization (binding to DOM events)
})
